<template>
  <div class="flex flex-col w-full gap-3">
    <div class="container px-4 mx-auto my-8 sm:px-12 gap-4">
      <div class="flex justify-between w-full py-2">
    <label class="text-sm font-semibold ">Seccion {{ identificador.orden }} Texto</label>
    <button @click="handleDelete" type="button" class="px-4 py-2 text-white bg-red-500 w-max">Eliminar</button>
    </div>
    </div>
    <input type="hidden" :name="'section['+identificador.id+'][id]'" :value="identificador.id" />
    <textarea
      class="w-full"
      :name="'section['+identificador.id+'][context]'"
      :id="'editor-' + identificador.id"
      
    >
{{ textContent }}
    </textarea>
  </div>
</template>

<script>
export default {
  props: {
    identificador: {
      type: Object,
      default: { id: 1, color: "#fff", textColor: "#000", content: "" },
    },
    idproject:{
      type: Number,
    },
    index:{
      type: Number,
    },
  },
  data() {
    return {
      textContent: "",
      bgColor: "",
      textColor: "",
      preStyle:"",
      style:"",
    };
  },
  created() {

    this.bgColor=document.querySelector('#color').value;
      this.textColor=document.querySelector('#colortext').value;
      this.textContent = this.getText(this.identificador.content);

  },
  mounted() {
      document.querySelector('#color').addEventListener('change', this.handleChangeColor);
      document.querySelector('#colortext').addEventListener('change', this.handleChangeColor);
    this.mountEditor();
  },
  methods: {
      handleChangeColor(){
          if(this.preStyle===""){
              const tmpPre=`<style>*{background-color:${this.bgColor};color:${this.textColor};}</style>`;
            this.preStyle=tmpPre;
        }
        else{
            const tmpPre=this.style;
            this.preStyle=tmpPre;
        }
        this.bgColor=document.querySelector('#color').value;
        this.textColor=document.querySelector('#colortext').value;


        this.textContent = this.getText(tinymce.get(`editor-${this.identificador.id}`).getBody().innerHTML);
        console.log(this.textContent);
        tinymce.get(`editor-${this.identificador.id}`).setContent(this.textContent);
      },
    handleDelete(){
      this.axios.delete(`/api/project/${this.idproject}/projecttext/${this.identificador.orden}`).then(response => {
                // console.log(response.data);
      this.$emit('delete', this.index);
            });

    },
      mountEditor(){
        setTimeout(() => {
            
            let editorConfig = {
        path_absolute: "/",
        selector: `#editor-${this.identificador.id}`,
        height: "500px",
        language: "es",
        content_style: `@import url('https://fonts.googleapis.com/css2?family=Libre+Baskerville:ital,wght@0,400;0,700;1,400&family=Source+Code+Pro:ital,wght@0,200;0,300;0,400;0,500;0,600;0,700;0,900;1,200;1,300;1,400;1,500;1,600;1,700;1,900&display=swap');body {font-family: 'Libre Baskerville', monospace;}h1,h2,h3,h4,h5,h6 {font-family: 'Source Code Pro', serif;}`,
        font_formats:
          "Libre Baskerville=Libre Baskerville;Source Code Pro=Source Code Pro;Andale Mono=andale mono,times; Arial=arial,helvetica,sans-serif; Arial Black=arial black,avant garde; Book Antiqua=book antiqua,palatino; Comic Sans MS=comic sans ms,sans-serif; Courier New=courier new,courier; Georgia=georgia,palatino; Helvetica=helvetica; Impact=impact,chicago; Raleway=raleway; Symbol=symbol; Tahoma=tahoma,arial,helvetica,sans-serif; Terminal=terminal,monaco; Times New Roman=times new roman,times; Trebuchet MS=trebuchet ms,geneva; Verdana=verdana,geneva; Webdings=webdings; Wingdings=wingdings,zapf dingbats;",
        plugins: [
          "print preview fullpage paste importcss searchreplace",
          "autolink autosave save directionality code visualblocks",
          "visualchars fullscreen image link media template codesample",
          "table charmap hr pagebreak nonbreaking anchor toc insertdatetime",
          "advlist lists wordcount imagetools textpattern noneditable help",
          "charmap quickbars emoticons spellchecker",
        ],
        menubar: "file edit view insert format tools table help",
        toolbar:
          "undo redo  bold italic underline strikethrough  fontselect fontsizeselect formatselect alignleft aligncenter alignright alignjustify outdent indent numlist bullist  forecolor backcolor removeformat pagebreak charmap emoticons fullscreen preview save print insertfile image media template link anchor codesample fullpage ltr rtl styleselect",
         content_css: '/themes/krossov/css/app.css',
        importcss_append: true,
        relative_urls: false,
        file_picker_callback: function (callback, value, meta) {
          var x =
            window.innerWidth ||
            document.documentElement.clientWidth ||
            document.getElementsByTagName("body")[0].clientWidth;
          var y =
            window.innerHeight ||
            document.documentElement.clientHeight ||
            document.getElementsByTagName("body")[0].clientHeight;
  
          var cmsURL =
            editorConfig.path_absolute + "filemanager?editor=" + meta.fieldname;
          if (meta.filetype == "image") {
            cmsURL = cmsURL + "&type=Images";
          } else {
            cmsURL = cmsURL + "&type=Files";
          }
          tinyMCE.activeEditor.windowManager.openUrl({
            url: cmsURL,
            title: "Filemanager",
            width: x * 0.8,
            height: y * 0.8,
            resizable: "yes",
            close_previous: "no",
            onMessage: (api, message) => {
              callback(message.content);
            },
          });
        },
      };
  
      tinymce.init(editorConfig);
        }, 1000);
      },
    getText(text) {

      this.style=`<style>*{background-color:${this.bgColor};color:${this.textColor};}</style>`;
      return `<!DOCTYPE html>
      <html>
      <head>
      ${this.style}
      </head>
      <body>

      ${text}

      </body>
      </html>`;
    },
  },
};
</script>

<style>
</style>
